Index: /trunk/gli/src/org/greenstone/gatherer/gems/GEMSPreferences.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/GEMSPreferences.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/GEMSPreferences.java	(revision 8971)
@@ -35,4 +35,5 @@
 import javax.swing.*;
 import javax.swing.event.*;
+import javax.swing.border.*;
 import org.greenstone.gatherer.Configuration;
 import org.greenstone.gatherer.Dictionary;
@@ -51,21 +52,13 @@
     static final public String CONNECTION_PREFS = "connection";
     static final public String GENERAL_PREFS = "general";
-
-
     static final private Dimension LABEL_SIZE = new Dimension(280, 25);
-    static final private Dimension ROW_SIZE = new Dimension(640, 25);
     static final private Dimension SIZE = new Dimension(640, 345);
-    static final private String TRUE = "true";
-
-    // private CheckList warning_preferences_check_list;
-    private EmailField email_field;
+
+    //private EmailField email_field;
     private JButton apply_button;
     private JButton cancel_button;
     private JButton ok_button;
-    private JCheckBox use_subfields_checkbox;
-    
+
     private JCheckBox use_proxy_checkbox;
-    private JCheckBox view_extracted_metadata_checkbox;
-    
     private JCheckBox workflow_create;
     private JCheckBox workflow_mirror;
@@ -74,36 +67,25 @@
     private JCheckBox workflow_design;
     private JCheckBox workflow_export;
+
     private JComboBox language_combobox;
-    private JList language_limited_jlist;
-    
-    private JComboBox servlet_combobox; // GS3
-    private JComboBox site_combobox; // GS3
+    private JList language_limited_jlist;  
+    private JList language_code_jlist; 
+    private JComboBox servlet_combobox;
+    private JComboBox site_combobox;
     private JLabel interface_language_label;
     private JLabel language_label;
-    private JLabel library_path_label;
-    private JLabel predefined_label;
-    private JLabel program_label;
-    private JLabel proxy_host_label;
-    private JLabel proxy_port_label;
-    private JLabel title_label;
-    private JPanel servlet_pane;
+
     private JRadioButton assistant_mode_radio_button;
     private JRadioButton expert_mode_radio_button;
-    private JRadioButton librarian_mode_radio_button;
     private JRadioButton systems_mode_radio_button;
     private JSpinner proxy_port_field;
     private JTabbedPane tab_pane;
     private JTextArea mode_description_textarea;
-    private JTextField library_path_field;
-    private JTextField program_field;
     private JTextField proxy_host_field;
     private GEMSPreferences self;
 
     private String current_site_selection;
+
     public GEMSPreferences() {
-	this(GENERAL_PREFS);
-    }
-
-    public GEMSPreferences(String initial_view) {
 	// Initialize
 	super(Gatherer.g_man, true);
@@ -118,10 +100,4 @@
 	JPanel general_preferences = createGeneralPreferences();
 	tab_pane.add("Preferences.General", general_preferences);
-	//tab_pane.add("Preferences.Mode", createModePreferences());
-	// !! Temporarily disabled for the UNESCO CD-ROM !!
-	// tab_pane.add("Preferences.Workflow", createWorkflowPreferences());
-	//JPanel connection_preferences = createConnectionPreferences();
-	//tab_pane.add("Preferences.Connection", connection_preferences);
-	//tab_pane.add("Preferences.Warnings", createWarningPreferences());
         
 	Dictionary.register(tab_pane);
@@ -155,20 +131,9 @@
 	content_pane.add(button_pane, BorderLayout.SOUTH);
 
-	Dimension frame_size;// = Gatherer.g_man.getSize();
-	Point frame_location;// = Gatherer.g_man.getLocation();
-	//setLocation(frame_location.x + ((frame_size.width - SIZE.width) / 2), frame_location.y + ((frame_size.height - SIZE.height)));
-	//setLocation(((frame_size.width - SIZE.width) / 2), ((frame_size.height - SIZE.height)));
         setLocation(400, 300);
-
-	
 	tab_pane.setSelectedComponent(general_preferences);
-	
-
 	
 	// Clean up
 	general_preferences = null;
-	//connection_preferences = null;
-	frame_location = null;
-	frame_size = null;
 	cancel_button = null;
 	ok_button = null;
@@ -185,47 +150,4 @@
 	// Build the model of available languages
 	ArrayList dictionary_model = new ArrayList();
-
-	// Old method for determining what languages should be available in the combobox
-	/*
-	dictionary_model.add(new DictionaryEntry(Locale.ENGLISH));
-	File classes_folder = new File(Utility.BASE_DIR + StaticStrings.CLASSES_FOLDER);
-	File[] possible_dictionaries = classes_folder.listFiles();
-	for(int i = 0; i < possible_dictionaries.length; i++) {
-	    String filename = possible_dictionaries[i].getName();
-	    if(filename.endsWith(StaticStrings.PROPERTIES_FILE_EXTENSION) && filename.indexOf(StaticStrings.UNDERSCORE_CHARACTER) != -1) {
-		StringTokenizer tokenizer = new StringTokenizer(filename.substring(filename.indexOf(StaticStrings.UNDERSCORE_CHARACTER) + 1, filename.indexOf(StaticStrings.STOP_CHARACTER)), StaticStrings.UNDERSCORE_CHARACTER);
-		Locale locale = null;
-		switch(tokenizer.countTokens()) {
-		case 1:
-		    locale = new Locale(tokenizer.nextToken().toLowerCase());
-		    break;
-		case 2:
-		    locale = new Locale(tokenizer.nextToken().toLowerCase(), tokenizer.nextToken().toUpperCase());
-		    break;
-		}
-		tokenizer = null;
-		// Open the file and read the first line
-		String description = null;
-		try {
-		    BufferedReader br = new BufferedReader(new FileReader(possible_dictionaries[i]));
-		    String first_line = br.readLine();
-		    br.close();
-		    description = first_line.substring(first_line.indexOf(StaticStrings.COLON_CHARACTER) + 1);
-		}
-		catch(Exception error) {
-		}
-		DictionaryEntry entry = new DictionaryEntry(description, locale);
-		description = null;
-		locale = null;
-		if(!dictionary_model.contains(entry)) {
-		    dictionary_model.add(entry);
-		}
-		entry = null;
-	    }
-	    filename = null;
-	}
-	possible_dictionaries = null;
-	classes_folder = null;
-	*/
 
 	// The new method makes use of the successor to the languages.dat file, classes/xml/languages.xml
@@ -254,31 +176,8 @@
 	interface_language_label.setPreferredSize(LABEL_SIZE);
         
-        
 	Dictionary.registerText(interface_language_label, "GEMS.Preferences.Selected_Languages_Tooltip");
-	email_field = new EmailField(Configuration.getColor("coloring.error_background", false));
-	email_field.setText(Configuration.getEmail());
-	Dictionary.registerTooltip(email_field, "GEMS.Preferences.Selected_Languages_Tooltip");
-
-	// Extracted metadata
-		
-	//Dictionary.registerBoth(view_extracted_metadata_checkbox, "Preferences.General.View_Extracted_Metadata", "Preferences.General.View_Extracted_Metadata_Tooltip");
-
-	
-	// Show file sizes
-	use_subfields_checkbox = new JCheckBox();
-        JLabel use_subfields_checkbox_label = new JLabel();
-        use_subfields_checkbox_label.setPreferredSize(new Dimension(225, 30));
-	use_subfields_checkbox.setSelected(false);
-        use_subfields_checkbox.setVisible(false);
-        use_subfields_checkbox_label.setVisible(false);
-      
-     //  String blah = Configuration.getString("coloring.workspace_tree_background",true);
-        //  System.out.println("before"+ blah);
-          
-	if (Configuration.get("GEMS.Preferences.Use_Subelements", true)) {
-         	use_subfields_checkbox.setSelected(true);
-	}
-	Dictionary.registerBoth(use_subfields_checkbox_label, "GEMS.Preferences.Use_Subelements", "GEMS.Preferences.Use_Subelements_Tooltip");
-	
+	//email_field = new EmailField(Configuration.getColor("coloring.error_background", false));
+	//email_field.setText(Configuration.getEmail());
+	//Dictionary.registerTooltip(email_field, "GEMS.Preferences.Selected_Languages_Tooltip");
 
 	// Language
@@ -286,5 +185,4 @@
 	language_label = new JLabel();
 	language_label.setPreferredSize(LABEL_SIZE);
-        
    
 	Dictionary.registerText(language_label, "Preferences.General.Interface_Language");
@@ -299,30 +197,27 @@
 	    }
 	}
-    
-        //create language_limited_jlist
-        //String [] newer = {"blah", "asfd", "dfjdddd", "blee11" ,"asdfsdfsdf", "asdfdsf","asdfsdfsdf", "asdfdsf","asdfsdfsdf", "asdfdsf","safd", "safd", "safd", "safd"};
-        
-        
         
         //create language selected box, and high light the apprpropate ones
-         int [] selectedLanguages = new int[300];
-         int selectedLanguagesLength = 0;
-     
-            
-        //GemsLanguageManager gemsLangManager = new GemsLanguageManager("/home/arosmain/gsdl/gli/classes/xml/languages.xml");
+	int [] selectedLanguages = new int[300];
+	int selectedLanguagesLength = 0;
+                 
+	//GemsLanguageManager gemsLangManager = new GemsLanguageManager("/home/arosmain/gsdl/gli/classes/xml/languages.xml");
         GEMSLanguageManager gemsLangManager = new GEMSLanguageManager(Configuration.gsdl_path + "/gli/classes/xml/languages.xml");
-        
-         
-         language_limited_jlist = new JList(gemsLangManager.getLanguageCodesToArray());     
+
+	//Create the visible JList, and then another one with just the language codes. 
+	language_code_jlist = new JList(gemsLangManager.getLanguageCodesToArray());  
+	language_limited_jlist = new JList(gemsLangManager.getLanguageCodesAndNames());
+
+	//Set the list up to display tabs properly
+  	TabListCellRenderer renderer = new TabListCellRenderer();
+	renderer.setTabs(new int[] {50, 200, 300});
+	language_limited_jlist.setCellRenderer(renderer);
+
         String enabled_languages =  Configuration.getString("GEMS.Preferences.Selected_Languages", true);
-	//we have a string : enabled_languages that contains an array of strings delimited by comma's
+	//we have a string: enabled_languages that contains an array of strings delimited by comma's
         String []enabled_languages_split = enabled_languages.split(",");
         Object []language_codes_array = gemsLangManager.getLanguageCodesToArray();
         
-        //System.out.println("before: " +enabled_languages_split[0].toString() + " meh: " + enabled_languages);
-        Vector selected = new Vector();
-        
-        //for each enabled_languages_split
-            //check which languages match, and store the index in selectedLanguages
+        //for each enabled_languages_split, check which languages match, and store the index in selectedLanguages
         for(int k = 0; k < enabled_languages_split.length; k++) {
             
@@ -331,44 +226,17 @@
                 //if the codes  match, then include the index p into the vector selectedLanguages
                 if (language_codes_array[p].toString().toLowerCase().trim().compareTo(enabled_languages_split[k].toLowerCase().trim()) == 0)
-              {
-                 // System.out.println(language_codes_array[p].toString().toLowerCase().trim() + " " + enabled_languages_split[k].toLowerCase().trim());
-              
-               //  selected.add(p);
-                   selectedLanguages[selectedLanguagesLength] = p;
-                   selectedLanguagesLength++;
-                   language_limited_jlist.addSelectionInterval(p,p);
-              }
-             
-                
-            }
-            
-            
+		    {
+			selectedLanguages[selectedLanguagesLength] = p;
+			selectedLanguagesLength++;
+			language_limited_jlist.addSelectionInterval(p,p);
+		    }   
+            }   
         }
        
-        //selectedLanguages should contain the indices of the languages that should be selected as
-        //stated in enabled_languages
-     
-        //language_limited_jlist.setSelectedIndices(selectedLanguages);
-       // language_limited_jlist.addSelectionInterval(1,1);
-        //language_limited_jlist.setSelectedIndex(1);
-               
-        //because the very first language(index 0) gets chosen no matter what... 
-        //then I unselected the 0 index, and then check the config file to see if that particular language is
-        //indeed selected
-     //  language_limited_jlist.set
-        
- 
-        
-
 	// Connect
 	language_combobox.addActionListener(new LanguageComboboxListener());
 
 	// Layout
-        
         JScrollPane langScrollPane = new JScrollPane(language_limited_jlist);
-      
-        //langScrollPane.getViewport().setView(language_limited_jlist);
-        
-       // langScrollPane.setSize(175, 100);
         langScrollPane.setPreferredSize(new Dimension(100, 100));
 	lang_limited_pane.setLayout(new GridLayout(1,3));
@@ -376,5 +244,4 @@
 	lang_limited_pane.add(langScrollPane);
         
-        
 	language_pane.setLayout(new BorderLayout());
 	language_pane.add(language_label, BorderLayout.WEST);
@@ -382,12 +249,8 @@
         
 	general_pane.setBorder(org.greenstone.gatherer.gui.BorderFactory.createEmptyBorder(5,5,5,5));
-	//general_pane.setLayout(new GridLayout(4,1,0,5));
 	general_pane.setLayout(null);
-	
-         general_pane.add(lang_limited_pane);
+	general_pane.add(lang_limited_pane);
 	general_pane.add(language_pane);
 	//general_pane.add(view_extracted_metadata_checkbox);
-	general_pane.add(use_subfields_checkbox);
-        general_pane.add(use_subfields_checkbox_label);
         Insets general_pane_insets = general_pane.getInsets();
         
@@ -397,10 +260,4 @@
         language_pane.setBounds(20+general_pane_insets.left, 130+general_pane_insets.top, 
                             language_pane.getPreferredSize().width, language_pane.getPreferredSize().height);
-        
-        use_subfields_checkbox_label.setBounds(20+general_pane_insets.left, 200+general_pane_insets.top, 
-                            use_subfields_checkbox_label.getPreferredSize().width, use_subfields_checkbox_label.getPreferredSize().height);
-       
-        use_subfields_checkbox.setBounds(295+general_pane_insets.left, 200+general_pane_insets.top, 
-                            use_subfields_checkbox.getPreferredSize().width, use_subfields_checkbox.getPreferredSize().height);
        
 	return general_pane;
@@ -416,46 +273,5 @@
 	public void actionPerformed(ActionEvent event) {
 	    // Submit the various changes
-	    // Connection preferences
-	 /*   String program_str = program_field.getText();
-	    if(program_str.length() > 0 && program_str.indexOf("%1") == -1) {
-		program_str = program_str + " %1";
-	    }
-	    Configuration.setPreviewCommand(program_str);
-
-	    boolean site_changed = false;
-	    if (Gatherer.GS3) {
-		String current_site = Configuration.site_name;
-		String new_site =(String)site_combobox.getSelectedItem() ;
-		if (!new_site.equals(current_site)) {
-		    site_changed = true;
-		}
-		Configuration.setSiteAndServlet(new_site, (String)servlet_combobox.getSelectedItem());
-	    }
-		
-	    Configuration.set("general.use_proxy", true, use_proxy_checkbox.isSelected());
-	    Configuration.setString("general.proxy_host", true, proxy_host_field.getText());
-	    Configuration.setString("general.proxy_port", true, proxy_port_field.getValue() + "");
-	    Gatherer.setProxy();
-
-	    // General preferences
-	    Configuration.setEmail(email_field.getText());
-
-	    Configuration.set("general.show_file_size", Configuration.COLLECTION_SPECIFIC, use_subfields_checkbox.isSelected());
-	    // Force both workspace and collection trees to redraw
-	    if (Gatherer.g_man != null) {
-		Gatherer.g_man.refreshWorkspaceTree(DragTree.TREE_DISPLAY_CHANGED);
-		Gatherer.g_man.refreshCollectionTree(DragTree.TREE_DISPLAY_CHANGED);
-	    }
-*/
-            //save selected languages list box
-            
-            //goes here
-            
-            //save subfield checkbox
-            
-	    Configuration.set("Gems.Preferences.Use_Subelements", true, use_subfields_checkbox.isSelected());
-	  //  Gatherer.g_man.enrich_pane.valueChanged((TreeSelectionEvent) null); // Refresh metadata table
-
-            
+
             //save interface language
 	    String current_lang = Configuration.getLanguage();
@@ -465,83 +281,20 @@
 	    }
             
-            
-            
-            //////////////////////save language limited jlist selections
-            
-             Vector stringVector = new Vector();
-        
-             Object[] selectedValues = language_limited_jlist.getSelectedValues();
-             String concatString = new String();
-             
-             for(int k = 0; k < selectedValues.length; k++) {
-                // System.out.println(language_limited_jlist.getComponent(0).toString());//allSelectedLanguages[k]
-                 
-                 //System.out.println(selectedValues[k]);
-                 
-                 if(selectedValues.length-k > 1) 
-                 concatString = concatString.concat(selectedValues[k].toString() +",");
-                 else
-                 concatString = concatString.concat(selectedValues[k].toString());
-                   
+	    //Set language_code_jlist to have the same selections as the language_limited_jlist.
+	    //(before, there was only one JList, and it only contained the language codes).
+	    int[] selection = language_limited_jlist.getSelectedIndices();
+	    language_code_jlist.setSelectedIndices(selection);
+	    Object[] selectedValues = language_code_jlist.getSelectedValues();
+	    String concatString = new String();
+	    
+	    for(int k = 0; k < selectedValues.length; k++) { 
+		if(selectedValues.length-k > 1) 
+		    concatString = concatString.concat(selectedValues[k].toString() +",");
+		else
+		    concatString = concatString.concat(selectedValues[k].toString());
              }
             
-            
-           // System.out.println("final cat string: "+ concatString);
-            
-        
             Configuration.setString("GEMS.Preferences.Selected_Languages",true, concatString);
             
-            ///////////////////
-/*
-	    // Mode preferences
-	    int current_mode = Configuration.getMode();
-	    int new_mode;
-	    if(assistant_mode_radio_button.isSelected()) {
-		new_mode = Configuration.ASSISTANT_MODE;
-	    }
-	    else if(systems_mode_radio_button.isSelected()) {
-		new_mode = Configuration.SYSTEMS_MODE;
-	    }
-	    else if(expert_mode_radio_button.isSelected()) {
-		new_mode = Configuration.EXPERT_MODE;
-	    }
-	    else  {
-		new_mode = Configuration.LIBRARIAN_MODE;
-	    }
-	    // If there has been a change in modes, update the config, and also inform the persistant gui views that have a need to know
-	    if(new_mode != current_mode) {
-		Configuration.setMode(new_mode);
-		Collection collection = Gatherer.c_man.getCollection();
-		if (collection != null) {
-		    collection.cdm.modeChanged(new_mode);
-		}
-		Gatherer.g_man.modeChanged(new_mode);
-	    }
-	    // Warning preferences
-	    for(int i = 0; i < warning_preferences_check_list.getEntryCount(); i++) {
-		Entry entry = warning_preferences_check_list.get(i);
-		Configuration.set(entry.getProperty(), true, entry.isSelected());
-	    }
-
-	    if (Gatherer.GS3 && site_changed && Gatherer.c_man.getCollection()!=null) {
-		// shut down the collection
-		System.err.println("shutting down teh collection");
-		Gatherer.g_man.closeCurrentCollection();
-	    }
-*/
-	    // Workflow preferences
-	    // Configuration.set("workflow.mirror", false, workflow_mirror.isSelected());
-	    // Configuration.set("workflow.gather", false, workflow_gather.isSelected());
-	    // Configuration.set("workflow.enrich", false, workflow_enrich.isSelected());
-	    // Configuration.set("workflow.design", false, workflow_design.isSelected());
-	    // Configuration.set("workflow.export", false, workflow_export.isSelected());
-	    // Configuration.set("workflow.create", false, workflow_create.isSelected());
-	    // Gatherer.g_man.workflowUpdate("Mirror", workflow_mirror.isSelected());
-	    // Gatherer.g_man.workflowUpdate("Gather", workflow_gather.isSelected());
-	    // Gatherer.g_man.workflowUpdate("Enrich", workflow_enrich.isSelected());
-	    // Gatherer.g_man.workflowUpdate("Design", (workflow_design.isSelected() && Configuration.getMode() > Configuration.ASSISTANT_MODE));
-	    // Gatherer.g_man.workflowUpdate("Export", workflow_export.isSelected());
-	    // Gatherer.g_man.workflowUpdate("Create", workflow_create.isSelected());
-
 	    // Always save configuration changes immediately (in case the GLI crashes)
 	    Configuration.save();
@@ -592,50 +345,4 @@
     }
 
-    /** This listener updates the mode description depending on what mode is selected. */
-    private class ModeRadioButtonListener
-	implements ActionListener {
-	public void actionPerformed(ActionEvent event) {
-	    Object source = event.getSource();
-	    if(source == assistant_mode_radio_button) {
-		mode_description_textarea.setText(Dictionary.get("Preferences.Mode.Assistant_Description"));
-	    }
-	    else if(source == expert_mode_radio_button) {
-		mode_description_textarea.setText(Dictionary.get("Preferences.Mode.Expert_Description"));
-	    }
-	    else if(source == systems_mode_radio_button) {
-		mode_description_textarea.setText(Dictionary.get("Preferences.Mode.Systems_Description"));
-	    }
-	    else {
-		mode_description_textarea.setText(Dictionary.get("Preferences.Mode.Librarian_Description"));
-	    }
-	    source = null;
-	}
-    }
-
-    private class PredefinedActionListener
-	implements ActionListener {
-	public void actionPerformed(ActionEvent event) {
-	    JComboBox cb = (JComboBox) event.getSource();
-	    WorkflowElementWrapper element = (WorkflowElementWrapper) cb.getSelectedItem();
-	    CheckboxUpdater task = new CheckboxUpdater(element);
-	    SwingUtilities.invokeLater(task);
-	}
-
-	private class CheckboxUpdater
-	    implements Runnable {
-	    private WorkflowElementWrapper element;
-	    public CheckboxUpdater(WorkflowElementWrapper element) {
-		this.element = element;
-	    }
-	    public void run() {
-		workflow_create.setSelected(element.getEnabled("create"));
-		workflow_mirror.setSelected(element.getEnabled("mirror"));
-		workflow_gather.setSelected(element.getEnabled("gather"));
-		workflow_enrich.setSelected(element.getEnabled("enrich"));
-		workflow_design.setSelected(element.getEnabled("design"));
-		workflow_export.setSelected(element.getEnabled("export"));
-	    }
-	}
-    }
 
     private class LanguageComboboxListener
@@ -651,62 +358,94 @@
 	}
     }
-
-    private class SiteComboboxListener
-	implements ActionListener {
-	private boolean ignore_event=false;
-	public void actionPerformed(ActionEvent event) {
-	    System.err.println("event occurred "+event.paramString());
-	    String site = (String) site_combobox.getSelectedItem();
-	    System.err.println("new site = "+site);
-	    if (!site.equals(current_site_selection)) {
-		current_site_selection = site;
-		System.err.println("changed the current selection");
-		ArrayList servlet_options = Gatherer.servlet_config.getServletsForSite(current_site_selection);
-		if (servlet_options == null) {
-		    System.err.println("no servlets for this site");
-		    servlet_combobox.setModel(new DefaultComboBoxModel());
-		    Dictionary.registerTooltip(servlet_combobox, "Preferences.Connection.Servlet_Tooltip2");
-		    servlet_combobox.setEnabled(false);
-
-		} else {
-		    System.err.println(ArrayTools.objectArrayToString(servlet_options.toArray()));
-		    servlet_combobox.setModel(new DefaultComboBoxModel(servlet_options.toArray()));
-		    Dictionary.registerTooltip(servlet_combobox, "Preferences.Connection.Servlet_Tooltip");
-		    servlet_combobox.setEnabled(true);
-		}
-	    }
-	}    
-    }
-
-    private class UseProxyListener
-	implements ActionListener {
-	public void actionPerformed(ActionEvent event) {
-	    boolean enabled = use_proxy_checkbox.isSelected();
-	    Configuration.set("general.use_proxy", true, enabled);
-	    // Fortunately this is already driven by the event thread.
-	    proxy_host_field.setEnabled(enabled);
-	    proxy_port_field.setEnabled(enabled);
-	}
-    }
-
-    private class WorkflowElementWrapper {
-	private Element element;
-	private String text;
-	public WorkflowElementWrapper(Element element) {
-	    this.element = element;
-	}
-	public boolean getEnabled(String name) {
-	    boolean result = true;
-	    if(element.getAttribute(name).equalsIgnoreCase("false")) {
-		result = false;
-	    }
-	    return result;
-	}
-	public String toString() {
-	    if(text == null) {
-		text = element.getFirstChild().getNodeValue();
-	    }
-	    return text;
-	}
-    }
 }
+
+
+/**
+   A custom list renderer, to display tabs in the JList properly.
+
+   @see http://manning.com/sbe/files/uts2/Chapter10html/Chapter10.htm
+   Added by Matthew Whyte
+   Date last modified: 1/02/05
+ */
+class TabListCellRenderer extends JLabel implements ListCellRenderer
+{
+    protected static Border m_noFocusBorder;
+    protected FontMetrics m_fm = null;
+    protected Insets m_insets = new Insets(0, 0, 0, 0);
+    
+    protected int m_defaultTab = 50;
+    protected int[] m_tabs = null;
+    
+    public TabListCellRenderer()
+    {
+	super();
+	m_noFocusBorder = new EmptyBorder(1, 1, 1, 1);
+	setOpaque(true);
+	setBorder(m_noFocusBorder);
+    }
+
+    public Component getListCellRendererComponent(JList list,
+						  Object value, int index, boolean isSelected, boolean cellHasFocus)     
+    {         
+	setText(value.toString());
+	
+	setBackground(isSelected ? list.getSelectionBackground() : list.getBackground());
+	setForeground(isSelected ? list.getSelectionForeground() : list.getForeground());
+	
+	setFont(list.getFont());
+	setBorder((cellHasFocus) ? UIManager.getBorder("List.focusCellHighlightBorder") : m_noFocusBorder);
+	
+	return this;
+    }
+    
+    public void setDefaultTab(int defaultTab) { m_defaultTab = defaultTab; }
+    
+    public int getDefaultTab() { return m_defaultTab; }
+
+    public void setTabs(int[] tabs) { m_tabs = tabs; }
+
+    public int[] getTabs() { return m_tabs; }
+
+    public int getTab(int index)
+    {
+	if (m_tabs == null)
+	    return m_defaultTab*index;
+		
+	int len = m_tabs.length;
+	if (index >= 0 && index < len)
+	    return m_tabs[index];
+
+	return m_tabs[len-1] + m_defaultTab*(index-len+1);
+    }
+
+
+    public void paint(Graphics g)
+    {
+	m_fm = g.getFontMetrics();
+	
+	g.setColor(getBackground());
+	g.fillRect(0, 0, getWidth(), getHeight());
+	getBorder().paintBorder(this, g, 0, 0, getWidth(), getHeight());
+
+	g.setColor(getForeground());
+	g.setFont(getFont());
+	m_insets = getInsets();
+	int x = m_insets.left;
+	int y = m_insets.top + m_fm.getAscent();
+
+	StringTokenizer	st = new StringTokenizer(getText(), "\t");
+	while (st.hasMoreTokens()) 
+	{
+	      String sNext = st.nextToken();
+	      g.drawString(sNext, x, y);
+		x += m_fm.stringWidth(sNext);
+
+		if (!st.hasMoreTokens())
+		    break;
+		int index = 0;
+		while (x >= getTab(index))
+		    index++;
+		x = getTab(index);
+	}
+    }   
+}
